<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1, maximum-scale=1, user-scalable=no">
<title>Cockpit</title>
<style>
* {
  box-sizing: border-box;
}
html, body {
  position: relative;
  height: 100%;
  width: 100%;
  margin: 0;
  padding: 0;
}
#info-container {
  width: 100%;
  height: 25%;
}
#info-container .row {
  margin: auto;
  text-align: center;
}

#pad-container {
  width: 100%;
  height: 75%;
  position: relative;
}
#pad-wrapper {
  width: 100%;
  height: 100%;
  max-width: 400px;
  max-height: 400px;
  margin: auto;
  top: 50%;
  transform: translateY(-50%);
  position: relative;
}
#pad {
  max-height: 100%;
  padding-bottom: 100%;
  margin: auto;
  position: relative;
  border-radius: 50%;
  background:  radial-gradient(circle, #aaFFaa 5%, #EE2222 70%);
}
#pad .line {
  position: absolute;
  border: 1px solid #eee;
}
#pad .line.horizontal {
  top: calc(50% - 1px);
  width: 100%;
}
#pad .line.vertical {
  left: calc(50% - 1px);
  height: 100%;
}
#pad .line.rotate {
  transform: rotate(45deg);
  -webkit-transform: rotate(45deg); 
  -moz-transform: rotate(45deg);
}
</style>
</head>
<body>

<div id="info-container">
  <div id="info-status" class="row">Disconnected</div>
  <div id="info-power" class="row">L:0 R:0</div>
  <div class="row">
    <input type="button" value="on" onclick="controls.connect()">
    <input type="button" value="off" onclick="controls.disconnect()">
  </div>
</div>
<div id="pad-container">
<div id="pad-wrapper">
  <div id="pad">
    <div class="horizontal line"></div>
    <div class="horizontal line rotate"></div>
    <div class="vertical line"></div>
    <div class="vertical line rotate"></div>
  </div>
</div>
</div>

<script>
var maxAbsVal = function(val, max) {
  if(val > max) return max;
  if(val < -max) return -max;
  return val;
};

var radToDeg = function(rad) {
  return rad * 360/(2*Math.PI);
};

var inPercent = function(val, ref) {
  var n = val / ref * 100;
  return Math.round(maxAbsVal(n, 100));
};

//MAIN
var controls = (function(){

var connected, ws, wsIsBusy,
    wsIntervalId, calcTimeoutId,
    wakeIntervalId, wakeIntervalTime,
    motorIntervalId, motorIntervalTime,

    pad, padRadius, padCenter, padSensibility,
    infoStatus, infoPower, power;

var init = function() {
  pad = document.getElementById('pad');
  infoStatus = document.getElementById('info-status');
  infoPower = document.getElementById('info-power');

  padSensibility = 1.2;
  wakeIntervalTime = 333;
  motorIntervalTime = 100;
  connected = false;
  wsIsBusy = true;
  power = {};

  calcPadCenter();
  bindEventListeners();
};

var connect = function() {

  disconnect();

  var conn = new WebSocket('ws://'+location.host+'/rpc/');

  conn.onopen = onConnect;
  conn.onclose = onDisconnect;
  conn.onerror = onError();
  conn.onmessage = function() {
    //infoStatus.innerHTML = 'Msg: '+JSON.stringify(msg);
  };

  //wakeIntervalId = setInterval(wake, wakeIntervalTime);
  //motorIntervalId = setInterval(motor, motorIntervalTime);

  ws = conn;
};

var disconnect = function() {
  if(connected && ws) ws.close();
  else onDisconnect();
};

var onConnect = function() {
  infoStatus.innerHTML = 'Connected';

  wsIsBusy = true;
  clearInterval(wsIntervalId);
  wsIntervalId = setInterval(function() {
      if(ws.bufferedAmount == 0) wsIsBusy = false;
  }, 50);

  wakeIntervalId = setInterval(wake, wakeIntervalTime);
  motorIntervalId = setInterval(motor, motorIntervalTime);
  connected = true;
};

var onDisconnect = function() {
  infoStatus.innerHTML = 'Disconnected';
  clearInterval(wsIntervalId);
  clearInterval(wakeIntervalId);
  clearInterval(motorIntervalId);
  connected = false;
  ws = null;
};

var onError = function() {
  infoStatus.innerHTML = 'Disconnected by Error!';
  disconnect();
};



var calcPadCenter = function() {
  var pos = pad.getBoundingClientRect();
  padRadius = Math.round(pos.width / 2);
  padCenter = {
      x : Math.round(pos.left) + padRadius,
      y : Math.round(pos.top) + padRadius
  };
};

var onMouseMove = function(e) {
  e.touches = [{clientX: e.clientX, clientY: e.clientY}];
  onTouchMove(e);
}
     
var onTouchMove = function(e) {
clearTimeout(calcTimeoutId);
calcTimeoutId = setTimeout(function(){

  var x = e.touches[0].clientX - padCenter.x;
  var y = -(e.touches[0].clientY - padCenter.y);

  var nx = inPercent(x, padRadius);
  var ny = inPercent(y, padRadius);

  var h = Math.round( Math.sqrt( (nx*nx) + (ny*ny) ) ); //Hypotenuse

  var left = right = h;
  if (y<0) left = right = -h;

  var tanA = Math.abs(y)/Math.abs(x); //RAD
  var aTanA = Math.atan(tanA); //RAD
  var alpha = radToDeg(aTanA); //DEG
  var slope = 100/90*alpha; // in percent

  //powerA = h, powerB(slope) depends on totalPower(h=100%)
  if(x>0) right = left/100*slope;
  else left = right/100*slope;

  //set min
  if(h <= 20) left = right = 0;

  left = Math.round(maxAbsVal(left*padSensibility, 100), 10);
  right = Math.round(maxAbsVal(right*padSensibility, 100), 10);

  power = {
    submit : (left != power.left || right != power.right),
    left: left,
    right: right
  };

  infoPower.innerHTML = 'L:'+left + ' R:'+right;
},0)
};

var bindEventListeners = function() {
  pad.addEventListener('mousemove', onMouseMove);
  pad.addEventListener('touchmove', onTouchMove);
  window.addEventListener("resize", calcPadCenter);
};

var unbindEventListeners = function() {
  pad.removeEventListener('mousemove', onMouseMove);
  pad.removeEventListener('touchmove', onTouchMove);
  window.removeEventListener("resize", calcPadCenter);
};

var wake = function() {
  if(wsIsBusy) return;

  ws.send(JSON.stringify({
    'method': 'Wake', 
    'args': {}
  }));
};

var motor = function() {
  if(power.submit) infoStatus.innerHTML = 'true '+wsIsBusy;
  else infoStatus.innerHTML = 'false '+wsIsBusy;


  if(wsIsBusy || power.submit !== true) return;
  power.submit = false;
  ws.send(JSON.stringify({
    'method': 'Motor', 
    'args': {
      left : power.left,
      right : power.right
    }
  }));
};

//export
this.connect = connect;
this.disconnect = disconnect;

init();

return this;
})();
</script>
</body>
</html>